<script>
import { mapState } from 'vuex';
import { HAND_URLS } from '~/lib/constants';

export default {
  data() {
    return {
      isVisible: false,
      x: 0,
      y: 0
    };
  },
  mounted() {
    document.addEventListener('mousemove', (e) => this.onMouseMove(e));
  },
  computed: {
    ...mapState(['cursor']),
    cursorImg() {
      return `${this.$router.options.base}${HAND_URLS[this.cursor]}`;
    },
    cursorStyle() {
      return {
        left: `${this.x}px`,
        top: `${this.y}px`
      };
    }
  },
  methods: {
    onMouseMove(e) {
      this.isVisible = true;
      this.x = e.clientX;
      this.y = e.clientY;
    }
  }
};
</script>

<template>
  <div
    v-if="isVisible"
    :style="cursorStyle"
    class="fixed pointer-events-none w-6 h-6 -ml-2 -mt-2"
  >
    <img :src="cursorImg" />
  </div>
</template>

<style>
body {
  cursor: none !important;
}
</style>

<style scoped>
.cursor-adjust {
  position: relative;
  bottom: 8px;
  right: 8px;
}
</style>
